<?php

    /*
    Copyright 2006, 2008 Paul Westbrook (paul@westbrooks.org)
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */

	lt_include( PLOG_CLASS_PATH."class/action/admin/adminaction.class.php" );
	lt_include( PLOG_CLASS_PATH."plugins/rssimport/class/view/pluginrssimportconfigview.class.php" );
	lt_include( PLOG_CLASS_PATH."class/data/validator/httpurlvalidator.class.php" );
	lt_include( PLOG_CLASS_PATH."class/data/validator/stringvalidator.class.php" );
	
		
	/**
	 * updates the plugin configuration
	 */
	class PluginRssImportUpdateConfigAction extends AdminAction
	{
		var $_pluginEnabled;
		var $_feedurl;
		var $_accessKey;
//		var $_accessHosts;
		var $_titleFormat;
		var $_categoryId;
		
		function PluginRssImportUpdateConfigAction( $actionInfo, $request )
		{
			$this->AdminAction( $actionInfo, $request );
		}
		
		function validate()
		{

			$this->_pluginEnabled = $this->_request->getValue( "pluginEnabled" );
            		$this->_pluginEnabled = ($this->_pluginEnabled != "" );			

			$this->_feedurl = $this->_request->getValue( "feedurl" );

			$this->_accessKey = $this->_request->getValue( "accessKey" );

//			$this->_accessHosts = $this->_request->getValue( "accessHosts" );

			$this->_titleFormat = $this->_request->getValue( "titleFormat" );
			$this->_categoryId = $this->_request->getValue( "categoryId" );

			// This should validate the url
			$val = new HttpUrlValidator();
            		if( !$val->validate($this->_feedurl) ) {
                	    $this->_view = new PluginRssImportConfigView( $this->_blogInfo );
                	    $this->_view->setErrorMessage( $this->_locale->tr("rssimport_error_url"));
                	    $this->setCommonData();

                	    return false;
            		}

			// Make sure that key is specied
			if (!$this->_accessKey || $this->_accessKey == "")
			{
                	    $this->_view = new PluginRssImportConfigView( $this->_blogInfo );
                	    $this->_view->setErrorMessage( $this->_locale->tr("rssimport_error_missing_accesskey"));
                	    $this->setCommonData();

                	    return false;
			}

			// This should validate the url
			$val = new StringValidator();
            		if( !$val->validate($this->_accessKey) ) {
                	    $this->_view = new PluginRssImportConfigView( $this->_blogInfo );
                	    $this->_view->setErrorMessage( $this->_locale->tr("rssimport_error_invalid_accesskey"));
                	    $this->setCommonData();

                	    return false;
            		}

			// This should validate the url
			$val = new StringValidator();
            		if( !$val->validate($this->_accessKey) ) {
                	    $this->_view = new PluginRssImportConfigView( $this->_blogInfo );
                	    $this->_view->setErrorMessage( $this->_locale->tr("rssimport_error_invalid_accesskey"));
                	    $this->setCommonData();

                	    return false;
            		}

			// Make sure that titleFormat is specied
			if (!$this->_titleFormat || $this->_titleFormat == "")
			{
                	    $this->_view = new PluginRssImportConfigView( $this->_blogInfo );
                	    $this->_view->setErrorMessage( $this->_locale->tr("rssimport_error_missing_titleformat"));
                	    $this->setCommonData();

                	    return false;
			}

			// This should validate the url
			$val = new StringValidator();
            		if( !$val->validate($this->_titleFormat) ) {
                	    $this->_view = new PluginRssImportConfigView( $this->_blogInfo );
                	    $this->_view->setErrorMessage( $this->_locale->tr("rssimport_error_invalid_titleformat"));
                	    $this->setCommonData();

                	    return false;
            		}

			return true;
		}
		        
		function perform()
		{
		        // update the plugin configurations to blog setting
			$blogSettings = $this->_blogInfo->getSettings();
			$blogSettings->setValue( "plugin_rssimport_enabled", $this->_pluginEnabled );

			$blogSettings->setValue( "plugin_rssimport_feedurl", $this->_feedurl );

			$blogSettings->setValue( "plugin_rssimport_accessKey", $this->_accessKey);

//			$blogSettings->setValue( "plugin_rssimport_accessHosts", $this->_accessHosts);

			$blogSettings->setValue( "plugin_rssimport_titleFormat", $this->_titleFormat);            		

			$blogSettings->setValue( "plugin_rssimport_article_category_id", $this->_categoryId );
			$this->_blogInfo->setSettings( $blogSettings ); 
		

			// save the blogs settings
			$blogs = new Blogs();
            		if( !$blogs->updateBlog( $this->_blogInfo )) {
                	    $this->_view = new PluginRssImportConfigView( $this->_blogInfo );
                	    $this->_view->setErrorMessage( $this->_locale->tr("error_updating_settings"));
			    $this->setCommonData();

                	    return false;                       
            		}
			
			// if everything went ok...
			$this->_blogInfo->setSettings( $blogSettings );
            		$this->_session->setValue( "blogInfo", $this->_blogInfo );
            		$this->saveSession();
			
			$this->_view = new PluginRssImportConfigView( $this->_blogInfo );
			$this->_view->setSuccessMessage( $this->_locale->tr("rssimport_settings_saved_ok"));			
			$this->setCommonData();
			
			// clear the cache
			CacheControl::resetBlogCache( $this->_blogInfo->getId());					
            
			return true;		
		}
	}
?>
